package ink.wgink.interfaces.role;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.dtos.ZTreeDTO;
import ink.wgink.pojo.dtos.role.RoleDTO;
import ink.wgink.pojo.pos.RolePO;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: IRoleService
 * @Description: 角色
 * @Author: WangGeng
 * @Date: 2021/1/24 12:57
 * @Version: 1.0
 **/
public interface IRoleBaseService {

    /**
     * 角色详情
     *
     * @param params
     * @return
     */
    RoleDTO get(Map<String, Object> params);

    /**
     * 角色详情
     *
     * @param roleId 角色ID
     * @return
     */
    RoleDTO get(String roleId);

    /**
     * 角色列表
     *
     * @param params
     * @return
     */
    List<RoleDTO> list(Map<String, Object> params);

    /**
     * 角色列表
     *
     * @param ids
     * @return
     */
    List<RoleDTO> listByRoleIds(List<String> roleIds);

    /**
     * 角色列表
     *
     * @param params
     * @return
     */
    List<RolePO> listPO(Map<String, Object> params);

    /**
     * 角色列表
     *
     * @param roleIds
     * @return
     */
    List<RolePO> listPO(List<String> roleIds);

    /**
     * 角色列表，递归获取全部内容
     *
     * @param params
     * @return
     */
    List<RoleDTO> listAll(Map<String, Object> params);

    /**
     * 角色zTree列表
     *
     * @param params
     * @return
     */
    List<ZTreeDTO> listZTree(Map<String, Object> params);

    /**
     * 角色EasyUI列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<RoleDTO>> listPage(ListPage page);

    /**
     * 统计角色
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}
